
typedef void* (__stdcall *SSZCALLBACK)(void*, intptr_t, void*, intptr_t, intptr_t);
#define TUserFunc(R_TYPE, FUNC, ...) extern "C" R_TYPE __declspec(dllexport) __stdcall FUNC(Benry *ben, __VA_ARGS__)

const int g_AlignmentSize = 4;

inline intptr_t Aligner(const intptr_t i)
{
	return ((i+g_AlignmentSize-1)/g_AlignmentSize) * g_AlignmentSize;
}

template<typename TYPE> inline intptr_t Aliszof()
{
	return Aligner(sizeof(TYPE));
}

struct Benry
{
	void *handle;
	SSZCALLBACK callback;
	void* (__stdcall *newfunc)(intptr_t);
	void (__stdcall *deletefunc)(void*);
	static void SanshouWatashiHenkan(intptr_t & ip, int8_t* const stack)
	{
		if(ip < 0){
			ip &= INTPTR_MAX;
		}else{
			ip = (intptr_t)(stack + ip);
		}
	}
	Benry(const SSZCALLBACK cb, void *const hn, void *(__stdcall *const sn)(intptr_t), void (__stdcall *const sd)(void*))
	{
		callback = cb;
		handle = hn;
		newfunc = sn;
		deletefunc = sd;
	}
#ifndef SSZ_CORE
	void SetSSZFunc()
	{
		sszrefnewfunc = newfunc;
		sszrefdeletefunc = deletefunc;
	}
#endif
	static void ReftoWstr(PWCArray<wchar_t> &wstr, const Reference &strref)
	{
		wstr.Clear();
		if(!strref.null()) wstr.AddTail((wchar_t*)strref.atpos(), strref.len()/sizeof(wchar_t));
		wstr += L'\0';
	}
	static void WstrtoRef(Reference &strref, const wchar_t *wstr)
	{
		strref.releaseanddelete();
		strref.refnew(lstrlenW(wstr), sizeof(wchar_t));
		if(strref.len() > 0) memcpy(strref.atpos(), wstr, strref.len());
	}
	static void ReftoAstr(UINT CodePage, PWCArray<char> &astr, const Reference &strref)
	{
		astr.Clear();
		if(!strref.null()){
			astr.SetLength(
				WideCharToMultiByte(CodePage, 0,
					(wchar_t *)strref.atpos(), (int)strref.len()/sizeof(wchar_t),
					NULL, 0, NULL, NULL));
			WideCharToMultiByte(CodePage, 0,
				(wchar_t *)strref.atpos(), (int)strref.len()/sizeof(wchar_t),
				astr.GetData(), (int)astr.GetLength(), NULL, NULL);
		}
		astr += '\0';
	}
	static void AstrtoRef(UINT CodePage, Reference &strref, const char *astr)
	{
		strref.releaseanddelete();
		strref.refnew(MultiByteToWideChar(CodePage, 0, astr, -1, NULL, 0), sizeof(wchar_t));
		if(strref.len() > 0) MultiByteToWideChar(CodePage, 0, astr, -1, (wchar_t*)strref.atpos(), (int)strref.len()/sizeof(wchar_t));
		strref.length -= sizeof(wchar_t);
	}
};

