
#pragma comment(lib,"winmm.lib")

#include <windows.h>
#include <process.h>
#include <math.h>
#include "myintdef.h"
#include "PowerWildCard.h"
#include "LockSingler.h"
#include "StrIdxArray.h"
#include "CommandLine.h"


void* __stdcall MemoryKakuho(intptr_t size)
{
	return new int8_t[size];
}
LONG g_KaihouStopCount = 0;
PWCArray<void*> g_KaihouStopList;
LockSingler g_KaihouStopMutex;
void __stdcall MemoryKaihou(void *p)
{
	if(g_KaihouStopCount != 0){
		AutoLocker al(&g_KaihouStopMutex);
		g_KaihouStopList += p;
	}else{
		delete [] (int8_t*)p;
	}
}

void* (__stdcall *const sszrefnewfunc)(intptr_t) = MemoryKakuho;
void (__stdcall *const sszrefdeletefunc)(void*) = MemoryKaihou;

#include "typeid.h"

#include "arrayandref.hpp"

#define SSZ_CORE
#include "benry.hpp"
#undef SSZ_CORE

#include "errmes.hpp"

#include "tokenkind.h"

typedef void (__stdcall *MAIN_FUNC)();
template<typename GC> struct SSZStatic
{
	ErrMes ErrorMessage;
	PWCArray<wchar_t> exedir;
	GC CircularGC;
	PWCArray<void (__stdcall *)()> gbldel;
};

#include "source.hpp"

#include "sourcetree.hpp"


#include "anticircular.hpp"



#include "meireicode.h"


#include "compiler.hpp"

#include "virtualmachine.hpp"


#include "jitcompiler.hpp"




#include "sszdef.h"




struct GCDStruct
{
	HeapObj *hp;
	intptr_t rpid;
	SSZStatic<JunkanGoroshi> *ss;
	GCDStruct(SSZStatic<JunkanGoroshi> *sstat)
	{
		ss = sstat;
	}
};
void GC_Destructor_Proc(void *p)
{
	GCDStruct *pgcds;
	intptr_t j;
	pgcds = (GCDStruct*)p;
	InterlockedIncrement((LONG*)&pgcds->hp->head.refcount);
	for(j = 0; j < pgcds->hp->head.datasize; ){
#ifdef SSZ_JIT
		p = pgcds->hp->head.data+j;
		intptr_t calladr = (intptr_t)pgcds->ss->CircularGC.pbcode + pgcds->ss->CircularGC.AtPL(pgcds->rpid).GetConst()[1];
		__asm{
			push edi
			push esi
			push ebx
			mov edi,p
			call calladr
			pop ebx
			pop esi
			pop edi
		}
#else
		KasouKikai vm(pgcds->ss);
		vm.memberhensuu = (intptr_t)(pgcds->hp->head.data+j);
		vm.Jikkou(*pgcds->ss->CircularGC.pbcode, *pgcds->ss->CircularGC.pgres, *pgcds->ss->CircularGC.psot, pgcds->ss->CircularGC.AtPL(pgcds->rpid).GetConst()[1]);
#endif
		j += pgcds->ss->CircularGC.AtPL(pgcds->rpid).GetConst()[0];
	}
	pgcds->hp->delet();
	delete pgcds;
}
struct GCTStruct
{
	bool running;
	SSZStatic<JunkanGoroshi> *ss;
	GCTStruct(SSZStatic<JunkanGoroshi> *sstat)
	{
		ss = sstat;
	}
};
unsigned __stdcall GC_Thread_Proc(void *p)
{
	GCDStruct gcds(((GCTStruct*)p)->ss);
	PointerFlagTable pft;
	uint32_t ncnt, rcnt, jcnt, temp;
	int i;
	for(;;){
		if(((GCTStruct*)p)->ss->CircularGC.PopNode(gcds.hp, gcds.rpid)) do{
			((GCTStruct*)p)->ss->CircularGC.JunkanTansaku(gcds.hp, gcds.rpid, pft, ncnt, rcnt, jcnt, gcds.hp);
			temp = 0;
			if(ncnt-1 == rcnt && gcds.hp->head.refcount == jcnt){
				temp = ((GCTStruct*)p)->ss->CircularGC.KnouGet((HeapObj**)pft.memo.GetConst(), pft.memo.GetLength());
			}
			InterlockedDecrement(&g_KaihouStopCount);
			do{
				AutoLocker al(&g_KaihouStopMutex);
				if(g_KaihouStopCount > 0) break;
				for(i = 0; i < g_KaihouStopList.GetLength(); i++) delete [] (int8_t*)g_KaihouStopList.GetConst()[i];
				g_KaihouStopList.Clear();
			}while(false);
			if(temp != rcnt) continue;
			((GCTStruct*)p)->ss->CircularGC.RefDel(gcds.hp);
			_beginthread(GC_Destructor_Proc, 0, &(*(new GCDStruct(gcds.ss)) = gcds));
		}while(((GCTStruct*)p)->ss->CircularGC.PopNode(gcds.hp, gcds.rpid));
		else if(!((GCTStruct*)p)->running){
			break;
		}
		Sleep(100);
	}
	return 0;
}


const _TCHAR *const g_dtitle = _T("S-SIZE v1.7.9");

TUserFunc(void, Run, Reference r)
{
	PWCArray<wchar_t> str;
	SSZStatic<JunkanGoroshi> ss;
	STStatic<SourceTree<JunkanGoroshi>, JunkanGoroshi> ststat(&ss);
	SourceTree<JunkanGoroshi> sosu(&ststat);
	PWCArray<int8_t> gre;
	HANDLE handle;
	GCTStruct gcts(&ss);
	intptr_t i;
	CommandLineString cmdline;
	ben->ReftoWstr(str, r);
	cmdline.set(GetCommandLine());
	for(i = cmdline.get()[0].GetLength()-1; i >= 0; i--){
		if(cmdline.get()[0].GetConst()[i] == _T('\\') || cmdline.get()[0].GetConst()[i] == _T('/')) break;
	}
	ss.exedir.Clear();
	ss.exedir.AddTail(cmdline.get()[0].GetConst(), i+1);
	sosu.Clear();
	if(!sosu.FileRead(str.GetLength() > 1 ? str.GetConst() : L"main.ssz")){
		ss.ErrorMessage.mes += L'\0';
		MessageBox(NULL, ss.ErrorMessage.mes.GetConst(), g_dtitle, MB_OK);
		return;
	}
	ss.CircularGC.Clear();
#ifdef SSZ_JIT
	JITer jr(&sosu);
	HANDLE heap;
	MAIN_FUNC mai;
	heap = jr.Compile(mai, gre);
	if(heap == NULL){
		ss.ErrorMessage.mes += L'\0';
		MessageBox(NULL, ss.ErrorMessage.mes.GetConst(), g_dtitle, MB_OK);
		return;
	}
	ss.CircularGC.SetKankyou(&sosu, (const PWCArray<uint8_t>*)mai, &gre);
	gcts.running = true;
	handle = (HANDLE)_beginthreadex(NULL, 0, GC_Thread_Proc, &gcts, 0, NULL);
	mai();
	gcts.running = false;
	WaitForSingleObject(handle, INFINITE);
	CloseHandle(handle);
	HeapDestroy(heap);
#else
	OmCompiler omc(&ss);
	KasouKikai vm(&ss);
	PWCArray<uint8_t> byc;
	byc.Clear();
	if(!omc.Compile(sosu, byc, gre)){
		ss.ErrorMessage.mes += L'\0';
		MessageBox(NULL, ss.ErrorMessage.mes.GetConst(), g_dtitle, MB_OK);
		return;
	}
	if(str.GetLength() > 2 && (str.GetConst()[0] == _T('/') || str.GetConst()[1] == _T(':'))){
		for(i = str.GetLength()-1; i >= 0; i--){
			if(str.GetConst()[i] == _T('\\') || str.GetConst()[i] == _T('/')) break;
		}
		str.SetLength(i);
		str += L'\0';
		SetCurrentDirectory(str.GetConst());
	}
	ss.CircularGC.SetKankyou(&sosu, &byc, &gre);
	vm.Clear();
	gcts.running = true;
	handle = (HANDLE)_beginthreadex(NULL, 0, GC_Thread_Proc, &gcts, 0, NULL);
	if(!vm.Run(byc, gre, sosu)){
		MessageBox(NULL, _T("ُIłB"), g_dtitle, MB_OK);
	}else if(vm.stack.GetLength() != 0){
		MessageBox(NULL, _T("X^bNُłB"), g_dtitle, MB_OK);
	}
	gcts.running = false;
	WaitForSingleObject(handle, INFINITE);
	CloseHandle(handle);
#endif
	return;
}

