

struct KasouKikai
{
	typedef SourceTree<JunkanGoroshi> SrcTree;
	SSZStatic<JunkanGoroshi> *ss;
	template<typename TYPE> class StackArray : public PWCArray<TYPE>
	{
	public:
		TYPE* Pop(const intptr_t len)
		{
			return Data + (Length-=len);
		}
	};
	template<typename TYPE> class MainStackArray
	{
		TYPE *Data;
		intptr_t Length, ArrangementSize;
		void ReAlloc(const intptr_t &size)
		{
			TYPE *p;
			intptr_t i, j;
			if(size <= ArrangementSize) return;
			for(j = 1; size > j; j <<= 1){}
			p = new TYPE[j];
			for(i = ArrangementSize - Length; i < ArrangementSize; i++) p[i+j-ArrangementSize] = Data[i];
			delete [] Data;
			Data = p;
			ArrangementSize = j;
		}
		template<class T> MainStackArray& Load(T &x)
		{
			Clear();
			*this += x;
			return *this;
		}
	public:
		MainStackArray(const intptr_t Size = 0)
		{
			Length = 0;
			ArrangementSize = (Size >= 0) ? Size : 0;
			Data = new TYPE[ArrangementSize];
		}
		~MainStackArray()
		{
			delete [ArrangementSize] Data;
		}
		TYPE* Pop(const intptr_t len)
		{
			intptr_t l = Length;
			Length -= len;
			return Data + ArrangementSize - l;
		}
		void AddTop(const TYPE *const st, const intptr_t len)
		{
			intptr_t i;
			ReAlloc(Length+len);
			Length += len;
			for(i = 0; i < len; i++) Data[ArrangementSize-Length+i] = st[i];
		}
		void Delete()
		{
			Length = 0;
			delete [ArrangementSize] Data;
			Data = 0;
			ArrangementSize = 0;
		}
		void Clear()
		{
			Length = 0;
		}
		TYPE* GetEnd()
		{
			return Data + ArrangementSize;
		}
		TYPE* GetTop()
		{
			return Data + ArrangementSize - Length;
		}
		intptr_t GetLength() const
		{
			return Length;
		}
		intptr_t SetLength(const intptr_t l)
		{
			ReAlloc(l);
			Length = l;
			return Length;
		}
		MainStackArray& operator += (const TYPE &x)
		{
			ReAlloc(++Length);
			Data[ArrangementSize - Length] = x;
			return *this;
		}
	};
	struct CallBackStruct
	{
		KasouKikai *pvm;
		const PWCArray<uint8_t> *pbcode;
		PWCArray<int8_t> *pgres;
		SrcTree *stree;
	};
	struct ThreadStruct
	{
		CallBackStruct cbs;
		intptr_t calladr;
		intptr_t jigoshori;
		void *phikisuu;
		intptr_t hikisize;
	};
	struct RefnewStruct
	{
		CallBackStruct cbs;
		intptr_t calladr, csize;
	};
	MainStackArray<int8_t> stack;
	intptr_t localhensuu;
	StackArray<intptr_t> localstack;
	intptr_t memberhensuu;
	StackArray<intptr_t> memberstack;
	StackArray<intptr_t> callstack;
	StackArray<intptr_t> gbldellist;
	KasouKikai(SSZStatic<JunkanGoroshi> *sstat)
	{
		ss = sstat;
	}
	static void* __stdcall CallBack(void *pcbs, intptr_t calladr, void *phikisuu, intptr_t hikisize, intptr_t retsize)
	{
		StackArray<intptr_t> tmp;
		KasouKikai *pv;
		pv = ((CallBackStruct*)pcbs)->pvm;
		pv->stack.AddTop((int8_t*)phikisuu, hikisize);
		tmp = pv->callstack;
		pv->callstack.Clear();
		pv->Jikkou(*((CallBackStruct*)pcbs)->pbcode, *((CallBackStruct*)pcbs)->pgres, *((CallBackStruct*)pcbs)->stree, calladr);
		pv->callstack = tmp;
		return pv->stack.Pop(Aligner(retsize));
	}
	static unsigned __stdcall ThreadFunc(void *p)
	{
		KasouKikai vm(((ThreadStruct*)p)->cbs.stree->stat->ss);
		vm.Clear();
		((ThreadStruct*)p)->cbs.pvm = &vm;
		CallBack(&((ThreadStruct*)p)->cbs, ((ThreadStruct*)p)->calladr, ((ThreadStruct*)p)->phikisuu, ((ThreadStruct*)p)->hikisize, 0);
		if(((ThreadStruct*)p)->jigoshori != 0){
			vm.memberhensuu = (intptr_t)((ThreadStruct*)p)->phikisuu;
			CallBack(&((ThreadStruct*)p)->cbs, ((ThreadStruct*)p)->jigoshori, NULL, 0, 0);
		}
		delete [] (int8_t*)((ThreadStruct*)p)->phikisuu;
		delete (ThreadStruct*)p;
		return 0;
	}
	static void __stdcall RefclassnewCB(void *p, int8_t *data, intptr_t len)
	{
		StackArray<intptr_t> tmp;
		KasouKikai *pv;
		intptr_t i;
		pv = ((RefnewStruct*)p)->cbs.pvm;
		tmp = pv->callstack;
		pv->callstack.Clear();
		pv->MemberPush();
		for(i = 0; i < len; i += ((RefnewStruct*)p)->csize){
			pv->memberhensuu = (intptr_t)(data+i);
			pv->Jikkou(*((RefnewStruct*)p)->cbs.pbcode, *((RefnewStruct*)p)->cbs.pgres, *((RefnewStruct*)p)->cbs.stree, ((RefnewStruct*)p)->calladr);
		}
		pv->MemberPop();
		pv->callstack = tmp;
	}
	void Clear()
	{
		stack.Clear();
		localhensuu = 0;
		localstack.Clear();
		memberhensuu = 0;
		memberstack.Clear();
		callstack.Clear();
	}
	void HensuuAddressHenkan(intptr_t &ip)
	{
		ip = (intptr_t)(stack.GetEnd() + localhensuu + ip);
	}
	void MemberAddressHenkan(intptr_t &ip)
	{
		if(memberhensuu >= 0){
			ip = (intptr_t)((int8_t*)memberhensuu + ip);
		}else{
			ip = (intptr_t)(stack.GetEnd() + memberhensuu + ip);
		}
	}
	void GlobalAddressHenkan(intptr_t &ip, PWCArray<int8_t> &globalres)
	{
		ip = (intptr_t)(globalres.GetConst() + ip);
	}
	void SanshouAddressHenkan(intptr_t &ip)
	{
		if(ip < 0){
			ip = (intptr_t)(stack.GetEnd() + ip);
		}
	}
	void DRDSwitch(const int32_t id, HeapObj *const pho, const PWCArray<uint8_t> &bytecode, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t i;
		if(0 <= id && id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(id)->deladress > 0){
			KasouKikai vm(ss);
			for(i = 0; i < pho->head.datasize; ){
				vm.memberhensuu = (intptr_t)(pho->head.data+i);
				vm.Jikkou(bytecode, globalres, stree, stree.stat->funclist.Get(id)->deladress);
				i += stree.stat->funclist.Get(id)->GetMemberSize();
			}
		}else if(-1 >= id && id >= ENDCLASS_TYPEID){
			for(i = 0; i < pho->head.datasize; i += sizeof(Thread)){
				((Thread*)(pho->head.data+i))->wait();
			}
		}
	}
	void DynRefDelete(DynamicRef &dr, const PWCArray<uint8_t> &bytecode, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		if((intptr_t)dr.obj.pointer <= 0){
		}else if(InterlockedDecrement((LPLONG)&dr.obj.pointer->head.refcount) != 0){
			if(0 <= dr.typ && dr.typ <= ENDCLASS_TYPEID && stree.stat->funclist.Get(dr.typ)->IsJunkanAble()){
				ss->CircularGC.RefDwn(dr.obj.pointer);
			}
		}else{
			if(dr.obj.pointer->head.datasize > 0)  DRDSwitch(dr.typ, dr.obj.pointer, bytecode, globalres, stree);
			if(0 <= dr.typ && dr.typ <= ENDCLASS_TYPEID && stree.stat->funclist.Get(dr.typ)->IsJunkanAble()){
				ss->CircularGC.RefDel(dr.obj.pointer);
			}
			dr.obj.pointer->delet();
		}
		dr.init();
	}
	template<typename TYPE> void Push(const TYPE x)
	{
		stack.SetLength(stack.GetLength()+Aliszof<TYPE>());
		*(TYPE*)stack.GetTop() = x;
	}
	template<typename TYPE> TYPE Pop()
	{
		return *(TYPE*)(stack.Pop(Aliszof<TYPE>()));
	}
	template<typename TYPE1, typename TYPE2> void Cast()
	{
		Push((TYPE2)Pop<TYPE1>());
	}
	template<typename TYPE> void Minus()
	{
		*(TYPE*)stack.GetTop() *= -1;
	}
	template<typename TYPE> void Not()
	{
		TYPE *p;
		p = (TYPE*)stack.GetTop();
		*p = ~*p;
	}
	void NotBool()
	{
		bool *bp;
		bp = (bool*)stack.GetTop();
		*bp = !*bp;
	}
	template<typename TYPE> void Tasu()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) += Pop<TYPE>();
	}
	template<typename TYPE> void Hiku()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) -= Pop<TYPE>();
	}
	template<typename TYPE> void Kakeru()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) *= Pop<TYPE>();
	}
	template<typename TYPE> void Waru()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) /= Pop<TYPE>();
	}
	template<typename TYPE> void Amari()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) %= Pop<TYPE>();
	}
	template<typename TYPE> void And()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) &= Pop<TYPE>();
	}
	void AndBool()
	{
		bool *bp;
		bp = (bool*)(stack.Pop(Aliszof<bool>())+Aliszof<bool>());
		*bp = *bp && *(bool*)(stack.GetTop()-Aliszof<bool>());
	}
	template<typename TYPE> void Xor()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) ^= Pop<TYPE>();
	}
	void XorBool()
	{
		bool *bp;
		bp = (bool*)(stack.GetTop()+Aliszof<bool>());
		*bp = *bp != Pop<bool>();
	}
	template<typename TYPE> void Or()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) |= Pop<TYPE>();
	}
	void OrBool()
	{
		bool *bp;
		bp = (bool*)(stack.Pop(Aliszof<bool>())+Aliszof<bool>());
		*bp = *bp || *(bool*)(stack.GetTop()-Aliszof<bool>());
	}
	template<typename TYPE> void LShift()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) <<= Pop<TYPE>();
	}
	template<typename TYPE> void RShift()
	{
		*(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) >>= Pop<TYPE>();
	}
	template<typename TYPE> void Incl()
	{
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		++*(TYPE*)ip;
	}
	template<typename TYPE> void InclKaraAtai()
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		stack.SetLength(stack.GetLength()-Aliszof<intptr_t>()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		*(TYPE*)stack.GetTop() = ++*(TYPE*)ip;
	}
	template<typename TYPE> void InclKaraMaenoAtai()
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		stack.SetLength(stack.GetLength()-Aliszof<intptr_t>()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		*(TYPE*)stack.GetTop() = (*(TYPE*)ip)++;
	}
	template<typename TYPE> void Decl()
	{
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		--*(TYPE*)ip;
	}
	template<typename TYPE> void DeclKaraAtai()
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		stack.SetLength(stack.GetLength()-Aliszof<intptr_t>()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		*(TYPE*)stack.GetTop() = --*(TYPE*)ip;
	}
	template<typename TYPE> void DeclKaraMaenoAtai()
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		stack.SetLength(stack.GetLength()-Aliszof<intptr_t>()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		*(TYPE*)stack.GetTop() = (*(TYPE*)ip)--;
	}
	template<typename TYPE> void Dainyuu()
	{
		intptr_t ip;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		*(TYPE*)ip = *(TYPE*)stack.Pop(Aliszof<intptr_t>()+Aliszof<TYPE>());
	}
	template<typename TYPE> void DainyuuKaraSanshou()
	{
		intptr_t ip;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		*(TYPE*)ip = *(TYPE*)stack.Pop(Aliszof<TYPE>());
	}
	template<typename TYPE> void SanshouKaraSanshousaki()
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		stack.SetLength(stack.GetLength()-Aliszof<intptr_t>()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		*(TYPE*)stack.GetTop() = *(TYPE*)ip;
	}
	template<typename TYPE> void Equal()
	{
		bool b;
		b = *(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) == *(TYPE*)stack.Pop(Aliszof<TYPE>()*2);
		Push(b);
	}
	void EqualRef()
	{
		Reference *r1 = (Reference*)(stack.GetTop()+Aliszof<Reference>()), *r2 = (Reference*)stack.Pop(Aliszof<Reference>()*2);
		Push((r1->null() ? NULL : r1->atpos()) == (r2->null() ? NULL : r2->atpos()));
	}
	void EqualDynRef()
	{
		DynamicRef *dr1 = (DynamicRef*)(stack.GetTop()+Aliszof<DynamicRef>()), *dr2 = (DynamicRef*)stack.Pop(Aliszof<DynamicRef>()*2);
		Push((dr1->obj.null() ? NULL : dr1->obj.atpos()) == (dr2->obj.null() ? NULL : dr2->obj.atpos()));
	}
	template<typename TYPE> void NotEqual()
	{
		bool b;
		b = *(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) != *(TYPE*)stack.Pop(Aliszof<TYPE>()*2);
		Push(b);
	}
	void NotEqualRef()
	{
		Reference *r1 = (Reference*)(stack.GetTop()+Aliszof<Reference>()), *r2 = (Reference*)stack.Pop(Aliszof<Reference>()*2);
		Push((r1->null() ? NULL : r1->atpos()) != (r2->null() ? NULL : r2->atpos()));
	}
	void NotEqualDynRef()
	{
		DynamicRef *dr1 = (DynamicRef*)(stack.GetTop()+Aliszof<DynamicRef>()), *dr2 = (DynamicRef*)stack.Pop(Aliszof<DynamicRef>()*2);
		Push((dr1->obj.null() ? NULL : dr1->obj.atpos()) != (dr2->obj.null() ? NULL : dr2->obj.atpos()));
	}
	template<typename TYPE> void Shou()
	{
		bool b;
		b = *(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) < *(TYPE*)stack.Pop(Aliszof<TYPE>()*2);
		Push(b);
	}
	template<typename TYPE> void ShouorEqual()
	{
		bool b;
		b = *(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) <= *(TYPE*)stack.Pop(Aliszof<TYPE>()*2);
		Push(b);
	}
	template<typename TYPE> void Dai()
	{
		bool b;
		b = *(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) > *(TYPE*)stack.Pop(Aliszof<TYPE>()*2);
		Push(b);
	}
	template<typename TYPE> void DaiorEqual()
	{
		bool b;
		b = *(TYPE*)(stack.GetTop()+Aliszof<TYPE>()) >= *(TYPE*)stack.Pop(Aliszof<TYPE>()*2);
		Push(b);
	}
	template<typename TYPE> void PopToHensuu(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		*(TYPE*)ip = Pop<TYPE>();
	}
	void PopToLocalStack()
	{
		localstack += localhensuu;
		localhensuu = Pop<intptr_t>();
	}
	void PopToMemberStack()
	{
		memberstack += memberhensuu;
		memberhensuu = Pop<intptr_t>();
	}
	template<typename TYPE> void PushTeisuu(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		i++;
		Push(*(TYPE*)(bytecode.GetConst()+i));
		i += sizeof(TYPE) - 1;
	}
	template<typename TYPE> void PushStack()
	{
		Push(*(TYPE*)stack.GetTop());
	}
	template<typename TYPE> void PushHensuu(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		Push(*(TYPE*)ip);
	}
	template<typename TYPE> void PushMemberHensuu(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		MemberAddressHenkan(ip);
		Push(*(TYPE*)ip);
	}
	template<typename TYPE> void PushGlobalHensuu(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		GlobalAddressHenkan(ip, globalres);
		Push(*(TYPE*)ip);
	}
	template<typename TYPE> void PushStackSanshousaki()
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		SanshouAddressHenkan(ip);
		Push(*(TYPE*)ip);
	}
	void PushLocalRegister()
	{
		Push(localhensuu);
	}
	void PushMemberRegister()
	{
		Push(memberhensuu);
	}
	void HensuuKaraSanshou(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip += localhensuu;
		Push(ip);
	}
	void MemberKaraSanshou(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip += memberhensuu;
		Push(ip);
	}
	void GlobalKaraSanshou(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip += (intptr_t)globalres.GetConst();
		Push(ip);
	}
	void Load(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t dst, src, size;
		i++;
		size = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		dst = *(intptr_t*)(stack.GetTop()+Aliszof<intptr_t>());
		SanshouAddressHenkan(dst);
		src = *(intptr_t*)stack.Pop(Aliszof<intptr_t>()*2);
		SanshouAddressHenkan(src);
		memcpy((void*)dst, (void*)src, size);
	}
	void LoadKaraSanshou(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t dst, src, size;
		int8_t *p;
		i++;
		size = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		p = stack.Pop(Aliszof<intptr_t>());
		dst = *(intptr_t*)(p+Aliszof<intptr_t>());
		SanshouAddressHenkan(dst);
		src = *(intptr_t*)p;
		SanshouAddressHenkan(src);
		memcpy((void*)dst, (void*)src, size);
	}
	void LoadSanshouKaraSanshousaki(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip, size;
		i++;
		size = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip = *(intptr_t*)stack.GetTop();
		stack.SetLength(stack.GetLength()-Aliszof<intptr_t>()+Aligner(size));
		SanshouAddressHenkan(ip);
		memcpy(stack.GetTop(), (void*)ip, size);
	}
	void HensuuStackKakuho(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		stack.SetLength(stack.GetLength()+ip);
		localstack += localhensuu;
		localhensuu = -stack.GetLength();
	}
	void HensuuStackKaihou(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		stack.Pop(ip);
		localhensuu = *localstack.Pop(1);
	}
	void LocalPush()
	{
		localstack += localhensuu;
		localhensuu = -stack.GetLength();
	}
	void LocalPop()
	{
		localhensuu = *localstack.Pop(1);
	}
	void MemberPush()
	{
		memberstack += memberhensuu;
		memberhensuu = localhensuu;
	}
	void MemberPushHensuu(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		memberstack += memberhensuu;
		memberhensuu = localhensuu + ip;
	}
	void MemberPushMember(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		memberstack += memberhensuu;
		memberhensuu += ip;
	}
	void MemberPushGlobal(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		memberstack += memberhensuu;
		memberhensuu = (intptr_t)globalres.GetConst() + ip;
	}
	void MemberPop()
	{
		memberhensuu = *memberstack.Pop(1);
	}
	void BblDelPush(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		i++;
		gbldellist += *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
	}
	void Jump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		i++;
		i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
	}
	void SwitchJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		uint8_t i8;
		i++;
		i8 = *(uint8_t*)(bytecode.GetConst()+i);
		i++;
		i8 = (*((uint8_t*)stack.GetTop()+(i8>>1)) >> (i8&0x01)*4) & 0x0f;
		i = ((intptr_t*)(bytecode.GetConst()+i))[i8] - 1;
	}
	void TrueJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		i++;
		if(*(bool*)stack.GetTop()){
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void FalseJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		i++;
		if(!*(bool*)stack.GetTop()){
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void PopnTrueJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		i++;
		if(Pop<bool>()){
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void PopnFalseJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		i++;
		if(!Pop<bool>()){
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void Call(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		callstack += i + sizeof(intptr_t);
		i = ip - 1;
	}
	void StackCall(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		callstack += i + 1;
		i = Pop<intptr_t>() - 1;
	}
	void Return(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		if(callstack.GetLength() <= 0){
			i = bytecode.GetLength() - 1;
		}else{
			i = *callstack.Pop(1) - 1;
		}
	}
	template<typename TYPE> void HensuuSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		*(TYPE*)ip = 0;
	}
	void HensuuRefSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		((Reference*)ip)->init();
	}
	template<typename TYPE> void MemberSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		MemberAddressHenkan(ip);
		*(TYPE*)ip = 0;
	}
	void MemberRefSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		MemberAddressHenkan(ip);
		((Reference*)ip)->init();
	}
	template<typename TYPE> void GlobalSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		GlobalAddressHenkan(ip, globalres);
		*(TYPE*)ip = 0;
	}
	void GlobalRefSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		GlobalAddressHenkan(ip, globalres);
		((Reference*)ip)->init();
	}
	template<typename TYPE> void SanshouSetNull()
	{
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		*(TYPE*)ip = 0;
	}
	void SanshouRefSetNull()
	{
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		((Reference*)ip)->init();
	}
	void HensuuDynRefSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		((DynamicRef*)ip)->init();
	}
	void MemberDynRefSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		MemberAddressHenkan(ip);
		((DynamicRef*)ip)->init();
	}
	void GlobalDynRefSetNull(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		GlobalAddressHenkan(ip, globalres);
		((DynamicRef*)ip)->init();
	}
	void SanshouDynRefSetNull()
	{
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		((DynamicRef*)ip)->init();
	}
	void RefLen(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference *pr;
		i++;
		pr = (Reference*)stack.Pop(Aliszof<Reference>()-Aliszof<intptr_t>());
		*(intptr_t*)stack.GetTop() = pr->len() / *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
	}
	void DynRefTypeSize(SrcTree &stree)
	{
		DynamicRef *pd;
		pd = (DynamicRef*)stack.Pop(Aliszof<DynamicRef>()-Aliszof<intptr_t>());
		*(intptr_t*)stack.GetTop() = stree.TypeIdtoSize(pd->typ);
	}
	void DynRefTypeId()
	{
		DynamicRef *pd;
		pd = (DynamicRef*)stack.Pop(Aliszof<DynamicRef>()-Aliszof<int32_t>());
		*(int32_t*)stack.GetTop() = pd->typ;
	}
	void DynRefLen(SrcTree &stree)
	{
		DynamicRef *pd;
		pd = (DynamicRef*)stack.Pop(Aliszof<DynamicRef>()-Aliszof<intptr_t>());
		*(intptr_t*)stack.GetTop() = (pd->obj.len() > 0 ? pd->obj.len() / stree.TypeIdtoSize(pd->typ) : 0);
	}
	void RefPosSanshou()
	{
		Reference *pr;
		pr = (Reference*)stack.Pop(Aliszof<Reference>()-Aliszof<intptr_t>());
		*(intptr_t*)stack.GetTop() = (intptr_t)pr->atpos();
	}
	void RefIdxSanshou(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference *pr;
		i++;
		pr = (Reference*)(stack.Pop(Aliszof<Reference>())+Aliszof<intptr_t>());
		*(intptr_t*)stack.GetTop() = (intptr_t)(pr->refat(
			*(intptr_t*)(stack.GetTop()-Aliszof<Reference>()),
			*(intptr_t*)(bytecode.GetConst()+i)));
		i += sizeof(intptr_t) - 1;
	}
	void ListIdxSanshou(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference *pr;
		i++;
		pr = (Reference*)(stack.Pop(Aliszof<Reference>())+Aliszof<intptr_t>());
		*(intptr_t*)stack.GetTop() = (intptr_t)(pr->listat(
			*(intptr_t*)(stack.GetTop()-Aliszof<Reference>()),
			*(intptr_t*)(bytecode.GetConst()+i)));
		i += sizeof(intptr_t) - 1;
	}
	void SanshouRefDelete()
	{
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		if(((Reference*)ip)->null()) return;
		((Reference*)ip)->pointer->delet();
		((Reference*)ip)->init();
	}
	void SanshouRefDownNZJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		SanshouAddressHenkan(ip);
		i++;
		if((intptr_t)((Reference *)ip)->pointer <= 0 || InterlockedDecrement((LPLONG)&((Reference*)ip)->pointer->head.refcount) != 0){
			((Reference*)ip)->init();
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			if(((Reference*)ip)->pointer->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				((Reference*)ip)->pointer->delet();
				((Reference*)ip)->init();
				i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	void SanshouRefNew(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t ii, ip, sz, ca;
		ii = Pop<intptr_t>();
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		i++;
		sz = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		ca = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		if(ca == 0){
			((Reference*)ip)->refnew(ii, sz);
		}else if(ca == -1){
			((Reference*)ip)->refnew(ii, sz, refzeroclearcb);
		}else if(ca == -2){
			((Reference*)ip)->refnew(ii, sz, refdynnullclearcb);
		}else{
			RefnewStruct rs;
			rs.csize = sz;
			rs.calladr = ca;
			rs.cbs.pvm = this;
			rs.cbs.pbcode = &bytecode;
			rs.cbs.pgres = &globalres;
			rs.cbs.stree = &stree;
			((Reference*)ip)->refnew(ii, sz, RefclassnewCB, &rs);
		}
	}
	void SanshouListNew(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t ii, ip, sz, ca;
		ii = Pop<intptr_t>();
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		i++;
		sz = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		ca = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		if(ca == 0){
			((Reference*)ip)->listnew(ii, sz);
		}else if(ca == -1){
			((Reference*)ip)->listnew(ii, sz, refzeroclearcb);
		}else if(ca == -2){
			((Reference*)ip)->listnew(ii, sz, refdynnullclearcb);
		}else{
			RefnewStruct rs;
			rs.csize = sz;
			rs.calladr = ca;
			rs.cbs.pvm = this;
			rs.cbs.pbcode = &bytecode;
			rs.cbs.pgres = &globalres;
			rs.cbs.stree = &stree;
			((Reference*)ip)->listnew(ii, sz, RefclassnewCB, &rs);
		}
	}
	void SanshouListIdxNew(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t ip, ip2, ip3, ca;
		ip3 = Pop<intptr_t>();
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		i++;
		ip2 = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		ca = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		if(ca == 0){
			Push(((Reference*)ip)->listnewat(ip3, ip2));
		}else if(ca == -1){
			Push(((Reference*)ip)->listnewat(ip3, ip2, refzeroclearcb));
		}else if(ca == -2){
			Push(((Reference*)ip)->listnewat(ip3, ip2, refdynnullclearcb));
		}else{
			RefnewStruct rs;
			rs.csize = ip2;
			rs.calladr = ca;
			rs.cbs.pvm = this;
			rs.cbs.pbcode = &bytecode;
			rs.cbs.pgres = &globalres;
			rs.cbs.stree = &stree;
			Push(((Reference*)ip)->listnewat(ip3, ip2, RefclassnewCB, &rs));
		}
	}
	void SanshouRefCopyNZJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference rfc;
		HeapObj *ph;
		intptr_t ip;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<Reference>());
		SanshouAddressHenkan(ip);
		i++;
		rfc = *(Reference*)ip;
		ph = ((Reference*)ip)->copy(*(Reference*)stack.GetTop());
		*(Reference*)stack.GetTop() = rfc;
		if(ph == NULL){
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			if(ph->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				ph->delet();
				((Reference*)ip)->init();
				i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	void SanshouCircRefDelete()
	{
		HeapObj *ph;
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		if(((Reference*)ip)->null()) return;
		ph = ((Reference*)ip)->pointer;
		((Reference*)ip)->init();
		ss->CircularGC.RefDel(ph);
		ph->delet();
	}
	void SanshouCircRefDownNZJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		HeapObj *ph;
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		SanshouAddressHenkan(ip);
		i++;
		ph = ((Reference*)ip)->pointer;
		if(ph <= 0){
			((Reference*)ip)->init();
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else if(InterlockedDecrement((LPLONG)&ph->head.refcount) != 0){
			ss->CircularGC.RefDwn(ph);
			((Reference*)ip)->init();
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			if(ph->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				((Reference*)ip)->init();
				ph->delet();
				i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	void SanshouCircRefNew(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t ii, ip, rpid, sz, ca;
		ii = Pop<intptr_t>();
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		i++;
		rpid = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		sz = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		ca = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		if(ca == 0){
			((Reference*)ip)->refnew(ii, sz);
		}else if(ca == -1){
			((Reference*)ip)->refnew(ii, sz, refzeroclearcb);
		}else if(ca == -2){
			((Reference*)ip)->refnew(ii, sz, refdynnullclearcb);
		}else{
			RefnewStruct rs;
			rs.csize = sz;
			rs.calladr = ca;
			rs.cbs.pvm = this;
			rs.cbs.pbcode = &bytecode;
			rs.cbs.pgres = &globalres;
			rs.cbs.stree = &stree;
			((Reference*)ip)->refnew(ii, sz, RefclassnewCB, &rs);
		}
		if(!((Reference*)ip)->null()) ss->CircularGC.RefNew(rpid, ((Reference*)ip)->pointer);
	}
	void SanshouCircListNew(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t ii, ip, rpid, sz, ca;
		ii = Pop<intptr_t>();
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		i++;
		rpid = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		sz = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		ca = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		if(ca == 0){
			((Reference*)ip)->listnew(ii, sz);
		}else if(ca == -1){
			((Reference*)ip)->listnew(ii, sz, refzeroclearcb);
		}else if(ca == -2){
			((Reference*)ip)->listnew(ii, sz, refdynnullclearcb);
		}else{
			RefnewStruct rs;
			rs.csize = sz;
			rs.calladr = ca;
			rs.cbs.pvm = this;
			rs.cbs.pbcode = &bytecode;
			rs.cbs.pgres = &globalres;
			rs.cbs.stree = &stree;
			((Reference*)ip)->listnew(ii, sz, RefclassnewCB, &rs);
		}
		if(!((Reference*)ip)->null()) ss->CircularGC.RefNew(rpid, ((Reference*)ip)->pointer);
	}
	void SanshouCircListIdxNew(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t ip, ip2, ip3, rpid, ca;
		bool tmp;
		ip3 = Pop<intptr_t>();
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		i++;
		rpid = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		ip2 = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t);
		ca = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		tmp = ((Reference*)ip)->null();
		if(ca == 0){
			Push(((Reference*)ip)->listnewat(ip3, ip2));
		}else if(ca == -1){
			Push(((Reference*)ip)->listnewat(ip3, ip2, refzeroclearcb));
		}else if(ca == -2){
			Push(((Reference*)ip)->listnewat(ip3, ip2, refdynnullclearcb));
		}else{
			RefnewStruct rs;
			rs.csize = ip2;
			rs.calladr = ca;
			rs.cbs.pvm = this;
			rs.cbs.pbcode = &bytecode;
			rs.cbs.pgres = &globalres;
			rs.cbs.stree = &stree;
			Push(((Reference*)ip)->listnewat(ip3, ip2, RefclassnewCB, &rs));
		}
		if(tmp) ss->CircularGC.RefNew(rpid, ((Reference*)ip)->pointer);
	}
	void SanshouCircRefCopyNZJump(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference rfc;
		HeapObj *ph;
		intptr_t ip;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<Reference>());
		SanshouAddressHenkan(ip);
		i++;
		rfc = *(Reference*)ip;
		ph = ((Reference*)ip)->copy(*(Reference*)stack.GetTop());
		*(Reference*)stack.GetTop() = rfc;
		if(ph == NULL){
			if((intptr_t)rfc.pointer > 0) ss->CircularGC.RefDwn(rfc.pointer);
			i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
		}else{
			if(ph->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				((Reference*)ip)->init();
				ph->delet();
				i = *(intptr_t*)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	void SanshouDynRefDown(const PWCArray<uint8_t> &bytecode, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t ip;
		ip = *(intptr_t*)stack.GetTop();
		SanshouAddressHenkan(ip);
		DynRefDelete(*(DynamicRef*)ip, bytecode, globalres, stree);
	}
	void SanshouDynRefCopy(const PWCArray<uint8_t> &bytecode, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		HeapObj *ph, *oldp;
		intptr_t ip;
		int32_t id;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<DynamicRef>());
		SanshouAddressHenkan(ip);
		oldp = ((DynamicRef*)ip)->obj.pointer;
		id = ((DynamicRef*)ip)->typ;
		((DynamicRef*)ip)->typ = VOID_TYPEID;//GCXbĥ߂
		ph = ((DynamicRef*)ip)->obj.copy(((DynamicRef *)stack.GetTop())->obj);
		if(ph == NULL){
			if((intptr_t)oldp > 0 && 0 <= id && id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(id)->IsJunkanAble()){
				ss->CircularGC.RefDwn(oldp);
			}
		}else{
			if(ph->head.datasize > 0)  DRDSwitch(id, ph, bytecode, globalres, stree);
			if(0 <= id && id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(id)->IsJunkanAble()){
				ss->CircularGC.RefDel(ph);
			}
			ph->delet();
		}
		((DynamicRef*)ip)->typ = ((DynamicRef *)stack.Pop(Aliszof<DynamicRef>()))->typ;
	}
	void SanshouDynRefSet(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		HeapObj *ph, *oldp;
		intptr_t ip;
		int32_t id;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<Reference>());
		SanshouAddressHenkan(ip);
		i++;
		oldp = ((DynamicRef*)ip)->obj.pointer;
		id = ((DynamicRef*)ip)->typ;
		((DynamicRef*)ip)->typ = VOID_TYPEID;//GCXbĥ߂
		ph = ((DynamicRef*)ip)->obj.copy(*(Reference *)stack.Pop(Aliszof<Reference>()));
		if(ph == NULL){
			if((intptr_t)oldp > 0 && 0 <= id && id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(id)->IsJunkanAble()){
				ss->CircularGC.RefDwn(oldp);
			}
		}else{
			if(ph->head.datasize > 0)  DRDSwitch(id, ph, bytecode, globalres, stree);
			if(0 <= id && id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(id)->IsJunkanAble()){
				ss->CircularGC.RefDel(ph);
			}
			ph->delet();
		}
		((DynamicRef*)ip)->typ = *(int32_t*)(bytecode.GetConst()+i);
		i += sizeof(int32_t) - 1;
	}
	void DynRefGet(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		HeapObj *ph, *oldp;
		intptr_t ip;
		int32_t id;
		ip = *(intptr_t*)stack.Pop(Aliszof<DynamicRef>()+Aliszof<intptr_t>());
		SanshouAddressHenkan(ip);
		i++;
		id = ((DynamicRef*)(stack.GetTop()-Aliszof<DynamicRef>()))->typ;
		if(*(int32_t*)(bytecode.GetConst()+i) == id){
			oldp = ((Reference*)ip)->pointer;
			ph = ((Reference*)ip)->copy(((DynamicRef*)(stack.GetTop()-Aliszof<DynamicRef>()))->obj);
			if(ph == NULL){
				if((intptr_t)oldp > 0 && 0 <= id && id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(id)->IsJunkanAble()){
					ss->CircularGC.RefDwn(oldp);
				}
			}else{
				if(ph->head.datasize > 0)  DRDSwitch(id, ph, bytecode, globalres, stree); 
				if(0 <= id && id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(id)->IsJunkanAble()){
					ss->CircularGC.RefDel(ph);
				}
				ph->delet();
			}
			Push(true);
		}else{
			Push(false);
		}
		i += sizeof(int32_t) - 1;
	}
	void DynRefUp()
	{
		((DynamicRef*)stack.GetTop())->obj.countup();
	}
	void DynLock()
	{
		((DynamicRef*)stack.GetTop())->obj.lock();
	}
	void DynUnlock()
	{
		((DynamicRef*)stack.GetTop())->obj.unlock();
	}
	template<typename TYPE> void Append()
	{
		intptr_t ip, idx;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		idx = ((Reference*)ip)->addsize(1, sizeof(TYPE));
		*(TYPE*)(((Reference*)ip)->obj()->head.data+idx) = *(TYPE*)stack.Pop(Aliszof<intptr_t>()+Aliszof<TYPE>());
	}
	template<typename TYPE> void AppendKaraSanshou()
	{
		intptr_t ip, idx;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<TYPE>());
		SanshouAddressHenkan(ip);
		idx = ((Reference*)ip)->addsize(1, sizeof(TYPE));
		*(TYPE*)(((Reference*)ip)->obj()->head.data+idx) = *(TYPE*)stack.Pop(Aliszof<TYPE>());
	}
	void AppendRef()
	{
		Reference *p;
		intptr_t ip, idx, l;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<Reference>());
		SanshouAddressHenkan(ip);
		p = (Reference*)stack.Pop(Aliszof<intptr_t>()+Aliszof<Reference>());
		l = p->len();
		if(l > 0){
			idx = ((Reference*)ip)->addsize(l, 1);
			memcpy(((Reference*)ip)->obj()->head.data+idx, p->obj()->head.data+p->position, l);
		}
	}
	void AppendKaraSanshouRef()
	{
		Reference *p;
		intptr_t ip, idx, l;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<Reference>());
		SanshouAddressHenkan(ip);
		p = (Reference*)stack.Pop(Aliszof<Reference>());
		l = p->len();
		if(l > 0){
			idx = ((Reference*)ip)->addsize(l, 1);
			memcpy(((Reference*)ip)->obj()->head.data+idx, p->obj()->head.data+p->position, l);
		}
	}
	void LoadAppend(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference *p;
		intptr_t ip, idx, size;
		i++;
		size = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<intptr_t>());
		SanshouAddressHenkan(ip);
		p = (Reference*)ip;
		ip = *(intptr_t*)stack.Pop(Aliszof<intptr_t>()*2);
		SanshouAddressHenkan(ip);
		idx = p->addsize(1, size);
		memcpy(p->obj()->head.data+idx, (void*)ip, size);
	}
	void LoadAppendKaraSanshou(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference *p;
		intptr_t ip, idx, size;
		i++;
		size = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip = *(intptr_t*)(stack.GetTop()+Aliszof<intptr_t>());
		SanshouAddressHenkan(ip);
		p = (Reference*)ip;
		ip = *(intptr_t*)stack.Pop(Aliszof<intptr_t>());
		SanshouAddressHenkan(ip);
		idx = p->addsize(size, 1);
		memcpy(p->obj()->head.data+idx, (void*)ip, size);
	}
	void RefUp()
	{
		((Reference*)stack.GetTop())->countup();
	}
	void Slice(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		Reference *p;
		i++;
		p = (Reference*)(stack.Pop(Aliszof<intptr_t>()*2)+Aliszof<intptr_t>()*2);
		p->slice(
			*(intptr_t*)(stack.GetTop()-Aliszof<intptr_t>()),
			*(intptr_t*)(stack.GetTop()-Aliszof<intptr_t>()*2),
			*(intptr_t*)(bytecode.GetConst()+i));
		i += sizeof(intptr_t) - 1;
	}
	void Lock()
	{
		((Reference*)stack.GetTop())->lock();
	}
	void Unlock()
	{
		((Reference*)stack.GetTop())->unlock();
	}
	void SanshouThreadWait()
	{
		intptr_t ip;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		((Thread*)ip)->wait();
	}
	void SanshouThreadRun(const PWCArray<uint8_t> &bytecode, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		ThreadStruct *pts;
		intptr_t ip;
		pts = new ThreadStruct;
		pts->cbs.pbcode = &bytecode;
		pts->cbs.pgres = &globalres;
		pts->cbs.stree = &stree;
		pts->jigoshori = Pop<intptr_t>();
		pts->calladr = Pop<intptr_t>();
		pts->hikisize = Pop<intptr_t>();
		pts->phikisuu = new int8_t[pts->hikisize];
		memcpy(pts->phikisuu, stack.Pop(pts->hikisize), pts->hikisize);
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		((Thread*)ip)->create(ThreadFunc, pts);
	}
	void IdName(SrcTree &stree)
	{
		int32_t id;
		intptr_t r;
		r = Pop<intptr_t>();
		SanshouAddressHenkan(r);
		id = Pop<int32_t>();
		stree.TypeIdtoName(*(Reference*)r, id);
		Push(*(Reference*)r);
	}
	void ConstEval(const PWCArray<uint8_t> &bytecode, intptr_t &i)
	{
		int32_t tid;
		Reference r;
		SrcTree *pst;
		intptr_t idx, ip, t;
		PWCArray<intptr_t> type, last;
		Source<JunkanGoroshi> src(ss);
		i++;
		pst = *(SrcTree**)(bytecode.GetConst()+i);
		i += sizeof(SrcTree*) - 1;
		idx = 0;
		type = CONST_TOKEN;
		switch(tid = TokenTtoTypeId((intptr_t*)stack.GetTop(), idx)){
		case METHOD_TYPEID:
			idx++;
		case FUNC_TYPEID:
		case DELEGATE_TYPEID:
			type.AddTail((intptr_t*)stack.GetTop(), idx);
			FuncToken(type, (intptr_t*)stack.GetTop(), idx);
			break;
		default:
			type.AddTail((intptr_t*)stack.GetTop(), idx);
		}
		stack.Pop(idx*sizeof(intptr_t));
		r = Pop<Reference>();
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		src.Clear();
		src.source.AddTail((wchar_t*)r.atpos(), r.len()/sizeof(wchar_t));
		t = 0;
		if(!pst->ConstShiki(src, t, NULL_TOKEN, src.GetToken(t), last, NULL_TOKEN, true)
			|| src.GetToken(t) != NULL_TOKEN || !pst->ConstCaster(last, type)){
			ss->ErrorMessage.Clear();
			Push(false);
			return;
		}
		switch(tid){
		case BYTE_TYPEID:
			*(int8_t*)ip = *(int8_t*)(last.GetConst()+idx+1);
			break;
		case UBYTE_TYPEID:
			*(uint8_t*)ip = *(uint8_t*)(last.GetConst()+idx+1);
			break;
		case SHORT_TYPEID:
			*(int16_t*)ip = *(int16_t*)(last.GetConst()+idx+1);
			break;
		case USHORT_TYPEID:
			*(uint16_t*)ip = *(uint16_t*)(last.GetConst()+idx+1);
			break;
		case INT_TYPEID:
			*(int32_t*)ip = *(int32_t*)(last.GetConst()+idx+1);
			break;
		case UINT_TYPEID:
			*(uint32_t*)ip = *(uint32_t*)(last.GetConst()+idx+1);
			break;
		case LONG_TYPEID:
			*(int64_t*)ip = *(int64_t*)(last.GetConst()+idx+1);
			break;
		case ULONG_TYPEID:
			*(uint64_t*)ip = *(uint64_t*)(last.GetConst()+idx+1);
			break;
		case CHAR_TYPEID:
			*(wchar_t*)ip = *(wchar_t*)(last.GetConst()+idx+1);
			break;
		case ADDRESS_TYPEID:
			*(intptr_t*)ip = *(intptr_t*)(last.GetConst()+idx+1);
			break;
		case FLOAT_TYPEID:
			*(float*)ip = *(float*)(last.GetConst()+idx+1);
			break;
		case DOUBLE_TYPEID:
			*(double*)ip = *(double*)(last.GetConst()+idx+1);
			break;
		case BOOL_TYPEID:
			*(bool*)ip = *(bool*)(last.GetConst()+idx+1);
			break;
		case FUNC_TYPEID:
		case METHOD_TYPEID:
			*(intptr_t*)ip = pst->stat->funclist.Get(*(int32_t*)(last.GetConst()+idx+1))->byteadress;
			break;
		default:
			Push(false);
			return;
		}
		Push(true);
	}
	void PluginCall(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int8_t> &globalres, SrcTree &stree, PWCArray<int32_t> &arg)
	{
		CallBackStruct cbs;
		Benry ben(CallBack, &cbs, sszrefnewfunc, sszrefdeletefunc), *pben = &ben;
		intptr_t ip, ip2;
		uint8_t ui8;
		int32_t *p, *pend;
		float fl;
		double dl, *pdl = &dl;
		i++;
		ui8 = bytecode.GetConst()[i];
		i++;
		ip = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		cbs.pvm = this;
		cbs.pbcode = &bytecode;
		cbs.pgres = &globalres;
		cbs.stree = &stree;
		p = arg.GetData();
		pend = arg.GetData()+arg.GetLength();
		switch(ui8){
		case 0:
			__asm{
				mov ecx,pend
				mov edx,p
			loop_0:
				cmp edx,ecx
				jnb loop_0e
				push dword ptr [edx]
				add edx,4
				jmp loop_0
			loop_0e:
				push pben;
				call ip
			}
			break;
		case 1:
			__asm{
				mov ecx,pend
				mov edx,p
			loop_1:
				cmp edx,ecx
				jnb loop_1e
				push dword ptr [edx]
				add edx,4
				jmp loop_1
			loop_1e:
				push pben;
				call ip
				mov ip,eax
			}
			Push((int8_t)ip);
			break;
		case 2:
			__asm{
				mov ecx,pend
				mov edx,p
			loop_2:
				cmp edx,ecx
				jnb loop_2e
				push dword ptr [edx]
				add edx,4
				jmp loop_2
			loop_2e:
				push pben;
				call ip
				mov ip,eax
			}
			Push((int16_t)ip);
			break;
		case 4:
			__asm{
				mov ecx,pend
				mov edx,p
			loop_4:
				cmp edx,ecx
				jnb loop_4e
				push dword ptr [edx]
				add edx,4
				jmp loop_4
			loop_4e:
				push pben;
				call ip
				mov ip,eax
			}
			Push((int32_t)ip);
			break;
		case 8:
			__asm{
				mov ecx,pend
				mov edx,p
			loop_8:
				cmp edx,ecx
				jnb loop_8e
				push dword ptr [edx]
				add edx,4
				jmp loop_8
			loop_8e:
				push pben;
				call ip
				mov ip,eax
				mov ip2,edx
			}
			Push((int64_t)ip | ((int64_t)ip2<<32));
			break;
		case 128 + 4:
			__asm{
				mov ecx,pend
				mov edx,p
			loop_F:
				cmp edx,ecx
				jnb loop_Fe
				push dword ptr [edx]
				add edx,4
				jmp loop_F
			loop_Fe:
				push pben;
				call ip
				fstp fl
			}
			Push(fl);
			break;
		case 128 + 8:
			__asm{
				mov ecx,pend
				mov edx,p
			loop_D:
				cmp edx,ecx
				jnb loop_De
				push dword ptr [edx]
				add edx,4
				jmp loop_D
			loop_De:
				push pben;
				call ip
				mov eax,pdl
				fstp qword ptr [eax]
			}
			Push(dl);
			break;
		}
		arg.Clear();
	}
	template<typename TYPE> void PoptoArg(PWCArray<int32_t> &arg)
	{
		intptr_t idx;
		if(sizeof(TYPE) <= g_AlignmentSize){
			arg.SetLength(arg.GetLength()+1);
			*(TYPE*)(arg.GetConst()+arg.GetLength()-1) = Pop<TYPE>();
		}else{
			arg.SetLength(arg.GetLength()+Aliszof<TYPE>()/g_AlignmentSize);
			for(idx = 1; idx <= Aliszof<TYPE>()/g_AlignmentSize; idx++){
				*(int32_t*)(arg.GetConst()+arg.GetLength() - idx) = Pop<int32_t>();
			}
		}
	}
	void LoadSanshoutoArg(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int32_t> &arg)
	{
		intptr_t ip, idx, size;
		i++;
		size = (*(intptr_t*)(bytecode.GetConst()+i)+g_AlignmentSize-1) / g_AlignmentSize;
		i += sizeof(intptr_t) - 1;
		ip = Pop<intptr_t>();
		SanshouAddressHenkan(ip);
		arg.SetLength(arg.GetLength()+size);
		for(idx = 1; idx <= size; idx++){
			*(int32_t*)(arg.GetConst()+arg.GetLength() - idx) = *((int32_t*)ip+idx-1);
		}
	}
	void ArgSanshouKaraAddress(const PWCArray<uint8_t> &bytecode, intptr_t &i, PWCArray<int32_t> &arg)
	{
		intptr_t idx;
		i++;
		idx = *(intptr_t*)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		SanshouAddressHenkan(arg.GetData()[idx]);
	}
	bool Jikkou(const PWCArray<uint8_t> &bytecode, PWCArray<int8_t> &globalres, SrcTree &stree, const intptr_t calladr)
	{
		PWCArray<int32_t> plgarg;
		intptr_t i;
		i = calladr - 1;
		goto INDEXLOOPEND;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int8_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int8_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int8_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int8_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int8_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int8_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int8_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int8_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int8_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int8_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int8_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int8_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int8_t>(); break;
			case NOT_MEIREI: Not<int8_t>(); break;
			case TASU_MEIREI: Tasu<int8_t>(); break;
			case HIKU_MEIREI: Hiku<int8_t>(); break;
			case KAKERU_MEIREI: Kakeru<int8_t>(); break;
			case WARU_MEIREI: Waru<int8_t>(); break;
			case AMARI_MEIREI: Amari<int8_t>(); break;
			case AND_MEIREI: And<int8_t>(); break;
			case XOR_MEIREI: Xor<int8_t>(); break;
			case OR_MEIREI: Or<int8_t>(); break;
			case LSHIFT_MEIREI: LShift<int8_t>(); break;
			case RSHIFT_MEIREI: RShift<int8_t>(); break;
			case INCL_MEIREI: Incl<int8_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int8_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int8_t>(); break;
			case DECL_MEIREI: Decl<int8_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int8_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int8_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int8_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int8_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int8_t>(); break;
			case EQUAL_MEIREI: Equal<int8_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int8_t>(); break;
			case SHOU_MEIREI: Shou<int8_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int8_t>(); break;
			case DAI_MEIREI: Dai<int8_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int8_t>(); break;
			case POP_MEIREI: Pop<int8_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int8_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int8_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int8_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int8_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int8_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int8_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<int8_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<int8_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<int8_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<int8_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<int8_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<int8_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int8_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<int8_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
BYTELOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int16_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int16_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int16_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int16_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int16_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int16_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int16_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int16_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int16_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int16_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int16_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int16_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int16_t>(); break;
			case NOT_MEIREI: Not<int16_t>(); break;
			case TASU_MEIREI: Tasu<int16_t>(); break;
			case HIKU_MEIREI: Hiku<int16_t>(); break;
			case KAKERU_MEIREI: Kakeru<int16_t>(); break;
			case WARU_MEIREI: Waru<int16_t>(); break;
			case AMARI_MEIREI: Amari<int16_t>(); break;
			case AND_MEIREI: And<int16_t>(); break;
			case XOR_MEIREI: Xor<int16_t>(); break;
			case OR_MEIREI: Or<int16_t>(); break;
			case LSHIFT_MEIREI: LShift<int16_t>(); break;
			case RSHIFT_MEIREI: RShift<int16_t>(); break;
			case INCL_MEIREI: Incl<int16_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int16_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int16_t>(); break;
			case DECL_MEIREI: Decl<int16_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int16_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int16_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int16_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int16_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int16_t>(); break;
			case EQUAL_MEIREI: Equal<int16_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int16_t>(); break;
			case SHOU_MEIREI: Shou<int16_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int16_t>(); break;
			case DAI_MEIREI: Dai<int16_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int16_t>(); break;
			case POP_MEIREI: Pop<int16_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int16_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int16_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int16_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int16_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int16_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int16_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<int16_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<int16_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<int16_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<int16_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<int16_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<int16_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int16_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<int16_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
SHORTLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int32_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int32_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int32_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int32_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int32_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int32_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int32_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int32_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int32_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int32_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int32_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int32_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int32_t>(); break;
			case NOT_MEIREI: Not<int32_t>(); break;
			case TASU_MEIREI: Tasu<int32_t>(); break;
			case HIKU_MEIREI: Hiku<int32_t>(); break;
			case KAKERU_MEIREI: Kakeru<int32_t>(); break;
			case WARU_MEIREI: Waru<int32_t>(); break;
			case AMARI_MEIREI: Amari<int32_t>(); break;
			case AND_MEIREI: And<int32_t>(); break;
			case XOR_MEIREI: Xor<int32_t>(); break;
			case OR_MEIREI: Or<int32_t>(); break;
			case LSHIFT_MEIREI: LShift<int32_t>(); break;
			case RSHIFT_MEIREI: RShift<int32_t>(); break;
			case INCL_MEIREI: Incl<int32_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int32_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int32_t>(); break;
			case DECL_MEIREI: Decl<int32_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int32_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int32_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int32_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int32_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int32_t>(); break;
			case EQUAL_MEIREI: Equal<int32_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int32_t>(); break;
			case SHOU_MEIREI: Shou<int32_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int32_t>(); break;
			case DAI_MEIREI: Dai<int32_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int32_t>(); break;
			case POP_MEIREI: Pop<int32_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int32_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int32_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int32_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int32_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int32_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int32_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<int32_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<int32_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<int32_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<int32_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<int32_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<int32_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int32_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<int32_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
INTLOOPEND:;
INDEXLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int64_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int64_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int64_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int64_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int64_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int64_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int64_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int64_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int64_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int64_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int64_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int64_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int64_t>(); break;
			case NOT_MEIREI: Not<int64_t>(); break;
			case TASU_MEIREI: Tasu<int64_t>(); break;
			case HIKU_MEIREI: Hiku<int64_t>(); break;
			case KAKERU_MEIREI: Kakeru<int64_t>(); break;
			case WARU_MEIREI: Waru<int64_t>(); break;
			case AMARI_MEIREI: Amari<int64_t>(); break;
			case AND_MEIREI: And<int64_t>(); break;
			case XOR_MEIREI: Xor<int64_t>(); break;
			case OR_MEIREI: Or<int64_t>(); break;
			case LSHIFT_MEIREI: LShift<int64_t>(); break;
			case RSHIFT_MEIREI: RShift<int64_t>(); break;
			case INCL_MEIREI: Incl<int64_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int64_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int64_t>(); break;
			case DECL_MEIREI: Decl<int64_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int64_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int64_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int64_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int64_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int64_t>(); break;
			case EQUAL_MEIREI: Equal<int64_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int64_t>(); break;
			case SHOU_MEIREI: Shou<int64_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int64_t>(); break;
			case DAI_MEIREI: Dai<int64_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int64_t>(); break;
			case POP_MEIREI: Pop<int64_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int64_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int64_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int64_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int64_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int64_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int64_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<int64_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<int64_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<int64_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<int64_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<int64_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<int64_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int64_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<int64_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
LONGLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint8_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint8_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint8_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint8_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint8_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint8_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint8_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint8_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint8_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint8_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint8_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint8_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint8_t>(); break;
			case NOT_MEIREI: Not<uint8_t>(); break;
			case TASU_MEIREI: Tasu<uint8_t>(); break;
			case HIKU_MEIREI: Hiku<uint8_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint8_t>(); break;
			case WARU_MEIREI: Waru<uint8_t>(); break;
			case AMARI_MEIREI: Amari<uint8_t>(); break;
			case AND_MEIREI: And<uint8_t>(); break;
			case XOR_MEIREI: Xor<uint8_t>(); break;
			case OR_MEIREI: Or<uint8_t>(); break;
			case LSHIFT_MEIREI: LShift<uint8_t>(); break;
			case RSHIFT_MEIREI: RShift<uint8_t>(); break;
			case INCL_MEIREI: Incl<uint8_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint8_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint8_t>(); break;
			case DECL_MEIREI: Decl<uint8_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint8_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint8_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint8_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint8_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint8_t>(); break;
			case EQUAL_MEIREI: Equal<uint8_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint8_t>(); break;
			case SHOU_MEIREI: Shou<uint8_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint8_t>(); break;
			case DAI_MEIREI: Dai<uint8_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint8_t>(); break;
			case POP_MEIREI: Pop<uint8_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint8_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint8_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint8_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint8_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint8_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint8_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<uint8_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<uint8_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<uint8_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<uint8_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<uint8_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<uint8_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint8_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<uint8_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
UBYTELOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint16_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint16_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint16_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint16_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint16_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint16_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint16_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint16_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint16_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint16_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint16_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint16_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint16_t>(); break;
			case NOT_MEIREI: Not<uint16_t>(); break;
			case TASU_MEIREI: Tasu<uint16_t>(); break;
			case HIKU_MEIREI: Hiku<uint16_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint16_t>(); break;
			case WARU_MEIREI: Waru<uint16_t>(); break;
			case AMARI_MEIREI: Amari<uint16_t>(); break;
			case AND_MEIREI: And<uint16_t>(); break;
			case XOR_MEIREI: Xor<uint16_t>(); break;
			case OR_MEIREI: Or<uint16_t>(); break;
			case LSHIFT_MEIREI: LShift<uint16_t>(); break;
			case RSHIFT_MEIREI: RShift<uint16_t>(); break;
			case INCL_MEIREI: Incl<uint16_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint16_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint16_t>(); break;
			case DECL_MEIREI: Decl<uint16_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint16_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint16_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint16_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint16_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint16_t>(); break;
			case EQUAL_MEIREI: Equal<uint16_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint16_t>(); break;
			case SHOU_MEIREI: Shou<uint16_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint16_t>(); break;
			case DAI_MEIREI: Dai<uint16_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint16_t>(); break;
			case POP_MEIREI: Pop<uint16_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint16_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint16_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint16_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint16_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint16_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint16_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<uint16_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<uint16_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<uint16_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<uint16_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<uint16_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<uint16_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint16_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<uint16_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
USHORTLOOPEND:;
CHARLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint32_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint32_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint32_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint32_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint32_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint32_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint32_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint32_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint32_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint32_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint32_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint32_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint32_t>(); break;
			case NOT_MEIREI: Not<uint32_t>(); break;
			case TASU_MEIREI: Tasu<uint32_t>(); break;
			case HIKU_MEIREI: Hiku<uint32_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint32_t>(); break;
			case WARU_MEIREI: Waru<uint32_t>(); break;
			case AMARI_MEIREI: Amari<uint32_t>(); break;
			case AND_MEIREI: And<uint32_t>(); break;
			case XOR_MEIREI: Xor<uint32_t>(); break;
			case OR_MEIREI: Or<uint32_t>(); break;
			case LSHIFT_MEIREI: LShift<uint32_t>(); break;
			case RSHIFT_MEIREI: RShift<uint32_t>(); break;
			case INCL_MEIREI: Incl<uint32_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint32_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint32_t>(); break;
			case DECL_MEIREI: Decl<uint32_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint32_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint32_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint32_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint32_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint32_t>(); break;
			case EQUAL_MEIREI: Equal<uint32_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint32_t>(); break;
			case SHOU_MEIREI: Shou<uint32_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint32_t>(); break;
			case DAI_MEIREI: Dai<uint32_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint32_t>(); break;
			case POP_MEIREI: Pop<uint32_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint32_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint32_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint32_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint32_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint32_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint32_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<uint32_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<uint32_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<uint32_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<uint32_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<uint32_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<uint32_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint32_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<uint32_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
UINTLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint64_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint64_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint64_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint64_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint64_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint64_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint64_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint64_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint64_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint64_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint64_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint64_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint64_t>(); break;
			case NOT_MEIREI: Not<uint64_t>(); break;
			case TASU_MEIREI: Tasu<uint64_t>(); break;
			case HIKU_MEIREI: Hiku<uint64_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint64_t>(); break;
			case WARU_MEIREI: Waru<uint64_t>(); break;
			case AMARI_MEIREI: Amari<uint64_t>(); break;
			case AND_MEIREI: And<uint64_t>(); break;
			case XOR_MEIREI: Xor<uint64_t>(); break;
			case OR_MEIREI: Or<uint64_t>(); break;
			case LSHIFT_MEIREI: LShift<uint64_t>(); break;
			case RSHIFT_MEIREI: RShift<uint64_t>(); break;
			case INCL_MEIREI: Incl<uint64_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint64_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint64_t>(); break;
			case DECL_MEIREI: Decl<uint64_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint64_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint64_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint64_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint64_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint64_t>(); break;
			case EQUAL_MEIREI: Equal<uint64_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint64_t>(); break;
			case SHOU_MEIREI: Shou<uint64_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint64_t>(); break;
			case DAI_MEIREI: Dai<uint64_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint64_t>(); break;
			case POP_MEIREI: Pop<uint64_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint64_t>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint64_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint64_t>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint64_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint64_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint64_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<uint64_t>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<uint64_t>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<uint64_t>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<uint64_t>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<uint64_t>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<uint64_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint64_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<uint64_t>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
ULONGLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<float, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<float, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<float, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<float, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<float, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<float, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<float, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<float, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<float, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<float, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<float, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<float, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<float>(); break;
			case TASU_MEIREI: Tasu<float>(); break;
			case HIKU_MEIREI: Hiku<float>(); break;
			case KAKERU_MEIREI: Kakeru<float>(); break;
			case WARU_MEIREI: Waru<float>(); break;
			case DAINYUU_MEIREI: Dainyuu<float>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<float>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<float>(); break;
			case EQUAL_MEIREI: Equal<float>(); break;
			case NOTEQUAL_MEIREI: NotEqual<float>(); break;
			case SHOU_MEIREI: Shou<float>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<float>(); break;
			case DAI_MEIREI: Dai<float>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<float>(); break;
			case POP_MEIREI: Pop<float>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<float>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<float>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<float>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<float>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<float>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<float>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<float>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<float>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<float>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<float>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<float>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<float>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<float>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<float>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
FLOATLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<double, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<double, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<double, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<double, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<double, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<double, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<double, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<double, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<double, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<double, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<double, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<double, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<double>(); break;
			case TASU_MEIREI: Tasu<double>(); break;
			case HIKU_MEIREI: Hiku<double>(); break;
			case KAKERU_MEIREI: Kakeru<double>(); break;
			case WARU_MEIREI: Waru<double>(); break;
			case DAINYUU_MEIREI: Dainyuu<double>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<double>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<double>(); break;
			case EQUAL_MEIREI: Equal<double>(); break;
			case NOTEQUAL_MEIREI: NotEqual<double>(); break;
			case SHOU_MEIREI: Shou<double>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<double>(); break;
			case DAI_MEIREI: Dai<double>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<double>(); break;
			case POP_MEIREI: Pop<double>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<double>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<double>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<double>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<double>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<double>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<double>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<double>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<double>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<double>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<double>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<double>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<double>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<double>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<double>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
DOUBLELOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<bool, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<bool, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<bool, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<bool, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<bool, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<bool, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<bool, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<bool, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<bool, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<bool, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<bool, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<bool, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case NOT_MEIREI: NotBool(); break;
			case AND_MEIREI: AndBool(); break;
			case XOR_MEIREI: XorBool(); break;
			case OR_MEIREI: OrBool(); break;
			case DAINYUU_MEIREI: Dainyuu<bool>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<bool>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<bool>(); break;
			case EQUAL_MEIREI: Equal<bool>(); break;
			case NOTEQUAL_MEIREI: NotEqual<bool>(); break;
			case POP_MEIREI: Pop<bool>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<bool>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<bool>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<bool>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<bool>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<bool>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<bool>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<bool>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuSetNull<bool>(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberSetNull<bool>(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalSetNull<bool>(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouSetNull<bool>(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: Append<bool>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<bool>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<bool>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
BOOLLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case NOP_MEIREI: break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<Reference>(); break;
			case EQUAL_MEIREI: EqualRef(); break;
			case NOTEQUAL_MEIREI: NotEqualRef(); break;
			case POP_MEIREI: Pop<Reference>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<Reference>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<Reference>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<Reference>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<Reference>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<Reference>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<Reference>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<Reference>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFCNTDOWN_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case SANSHOUREFCOPY_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case LEN_MEIREI: RefLen(bytecode, i); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case APPEND_MEIREI: AppendRef(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshouRef(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFCNTUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFCNTDOWN_MEIREI: SanshouCircRefDownNZJump(bytecode, i); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCREFCOPY_MEIREI: SanshouCircRefCopyNZJump(bytecode, i); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<Reference>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
REFLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case DYNREFTYPE_MEIREI: goto DYNREFLOOPEND;
			case NOP_MEIREI: break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<DynamicRef>(); break;
			case EQUAL_MEIREI: EqualDynRef(); break;
			case NOTEQUAL_MEIREI: NotEqualDynRef(); break;
			case POP_MEIREI: Pop<DynamicRef>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<DynamicRef>(bytecode, i); break;
			case POPTOLOCALSTACK_MEIREI: PopToLocalStack(); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHSTACK_MEIREI: PushStack<DynamicRef>(); break;
			case PUSHSTACKADDRESS_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<DynamicRef>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<DynamicRef>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<DynamicRef>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOUSAKI_MEIREI: PushStackSanshousaki<DynamicRef>(); break;
			case PUSHLOCALREGISTER_MEIREI: PushLocalRegister(); break;
			case PUSHMEMBERREGISTER_MEIREI: PushMemberRegister(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case LOCALPOP_MEIREI: LocalPop(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres, stree); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUSETNULL_MEIREI: HensuuDynRefSetNull(bytecode, i); break;
			case MEMBERSETNULL_MEIREI: MemberDynRefSetNull(bytecode, i); break;
			case GLOBALSETNULL_MEIREI: GlobalDynRefSetNull(bytecode, i, globalres); break;
			case SANSHOUSETNULL_MEIREI: SanshouDynRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFCNTDOWN_MEIREI: SanshouDynRefDown(bytecode, globalres, stree); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(bytecode, i, globalres, stree); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(bytecode, i, globalres, stree); break;
			case SANSHOUREFCOPY_MEIREI: SanshouDynRefCopy(bytecode, globalres, stree); break;
			case LEN_MEIREI: DynRefLen(stree); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(bytecode, i); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(bytecode, i); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFCNTUP_MEIREI: DynRefUp(); break;
			case SLICE_MEIREI: Slice(bytecode, i); break;
			case LOCK_MEIREI: DynLock(); break;
			case UNLOCK_MEIREI: DynUnlock(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres, stree); break;
			case SANSHOUCIRCREFDELETE_MEIREI: SanshouCircRefDelete(); break;
			case SANSHOUCIRCREFNEW_MEIREI: SanshouCircRefNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTNEW_MEIREI: SanshouCircListNew(bytecode, i, globalres, stree); break;
			case SANSHOUCIRCLISTIDXNEW_MEIREI: SanshouCircListIdxNew(bytecode, i, globalres, stree); break;
			case DYNREFTYPESIZE_MEIREI: DynRefTypeSize(stree); break;
			case DYNREFTYPEID_MEIREI: DynRefTypeId(); break;
			case SANSHOUDYNREFSET_MEIREI: SanshouDynRefSet(bytecode, i, globalres, stree); break;
			case DYNREFGET_MEIREI: DynRefGet(bytecode, i, globalres, stree); break;
			case PLUGINCALL_MEIREI: PluginCall(bytecode, i, globalres, stree, plgarg); break;
			case POPTOARG_MEIREI: PoptoArg<DynamicRef>(plgarg); break;
			case LOADSANSHOUTOARG_MEIREI: LoadSanshoutoArg(bytecode, i, plgarg); break;
			case ARGSANSHOUKARAADDRESS_MEIREI: ArgSanshouKaraAddress(bytecode, i, plgarg); break;
			case IDNAME_MEIREI: IdName(stree); break;
			case CONSTEVAL_MEIREI: ConstEval(bytecode, i); break;
			default: return false;
			}
DYNREFLOOPEND:;
		}
		return true;
	}
	bool Run(const PWCArray<uint8_t> &bytecode, PWCArray<int8_t> &globalres, SrcTree &stree)
	{
		intptr_t i;
		if(!Jikkou(bytecode, globalres, stree, 0)) return false;
		for(i = gbldellist.GetLength()-1; i >= 0; i--){
			if(!Jikkou(bytecode, globalres, stree, gbldellist.GetConst()[i])) return false;
		}
		gbldellist.Clear();
		return true;
	}
};

